//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Main.h"
#include "math.h"
#include <gl/gl.h>
#include <gl/glu.h>
#include <gl/glaux.h>



#include "stolicka.h"
#include "genpr.h"
#include "nastav.h"
#include "nastav2.h"
#include "podrobnosti.h"
#include "podrob2.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

   float uhelX=20;
   float uhelY;
   float uhelZ;
   float zoom=0;
   double R = 1.0,G = 0, B = 0;
   float pole[10][3];
   int v1,v2,v3;
  const GLfloat nRange = 10.0;
  prostr *gp;

  GLfloat materialAmbient[]={1.0f, 1.0f, 1.0f, 1.0f}; // ambientna zlozka farby materialu
  GLfloat materialDiffuse[]={0.0f, 0.0f, 0.0f, 0.0f};
  GLfloat light_position[]={0.0f, 10.0f, 10.0f, 1.0f}; // pozicia svetla
  GLfloat materialSpecular[]={1.0f, 1.0f, 1.0f, 1.0f}; // farba odlesku
  GLfloat materialShininess[]={50.0f};                 // faktor odlesku

#define TEXTURE_GROUND           0                     // mena textur pre vyber
#define TEXTURE_TABLE            1
#define TEXTURE_SEAT             2

  unsigned int textures[4];

//---------------------------------------------------------------------------

int TForm1::bitmapLoad(int texture, const char *filename)
{
  //nacitanie textur
    FILE          *fin;
    int           width, height, bpp=0;
    int           size;
    unsigned char *bitmap;
    unsigned char bmpHeader[54]={0x42, 0x4d,        // magicke cislo souboru BMP
                        0x00, 0x00, 0x00, 0x00,     // velikost souboru
                        0x00, 0x00, 0x00, 0x00,     // rezervovano, vzdy nastaveno na nula
                        0x36, 0x04, 0x00, 0x00,     // data offset=54
                        0x28, 0x00, 0x00, 0x00,     // velikost hlavicky=40
                        0x00, 0x00, 0x00, 0x00,     // sirka obrazku v pixelech=?
                        0x00, 0x00, 0x00, 0x00,     // vyska obrazku v pixelech=?
                        0x01, 0x00,                 // pocet bitovych rovin=1
                        0x08, 0x00,                 // pocet bitu na pixel=24
                        0x00, 0x00, 0x00, 0x00,     // metoda komprimace=nic
                        0x00, 0x00, 0x00, 0x00,     // velikost bitmapy
                        0x00, 0x00, 0x00, 0x00,     // pocet pixelu na metr v horizontalnim smeru
                        0x00, 0x00, 0x00, 0x00,     // pocet pixelu na metr ve vertikalnim smeru
                        0x00, 0x00, 0x00, 0x00,     // pocet pouzitych barev
                        0x00, 0x00, 0x00, 0x00,     // pocet dulezitych barev
    };

    if (!filename) return -1;
    fin=fopen(filename, "rb");
    if (!fin) return -1;                            // otevreni souboru se nezdarilo
    if (fread(bmpHeader, 54, 1, fin)!=1) return -1; // nacist hlavicku BMP souboru
    memcpy(&width, bmpHeader+18, 4);                // sirka obrazku v pixelech
    memcpy(&height, bmpHeader+22, 4);               // vyska obrazku v pixelech
    memcpy(&bpp, bmpHeader+28, 2);                  // pocet bitu na pixel
    if (bpp!=24) return -1;
    size=width*height*3;
    bitmap=(unsigned char *)malloc(size*sizeof(unsigned char));
    if (fread(bitmap, size, sizeof(unsigned char), fin)!=1) return -1;// nacteni rastrovych dat
    fclose(fin);

    int i;
    char c;

    for(i=0;i<width*height;i++){
      c=bitmap[3*i];
      bitmap[3*i]=bitmap[3*i+2];
      bitmap[3*i+2]=c;
      }

    glBindTexture(GL_TEXTURE_2D, texture);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexImage2D(GL_TEXTURE_2D, 0, 3, width, height,              // nacitanie textury do GPU
                 0, GL_RGB, GL_UNSIGNED_BYTE, bitmap);
    free(bitmap);
    return 0;
}

//---------------------------------------------------------------------------

__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
  FILE *sub;

  //nachystanie prazdnych suborov
 /* sub=fopen("fitness.txt","w");
  fclose(sub);
  sub=fopen("fit_casti.txt","w");
  fclose(sub);
 */
  randomize();

  Application->OnIdle = IdleLoop;

  TIniFile *ini;
   
  ini = new TIniFile(ChangeFileExt(Application->ExeName,".INI"));

  gp=new prostr(ini);       //nacita nastavenia ako su ulozene v ini subore a vytvori populaciu

  delete ini;

  if(gp->akt==0)prev->Enabled=false;
  if(gp->pocet-1==gp->akt)next->Enabled=false;
}
//---------------------------------------------------------------------------

__fastcall TForm1::~TForm1()
{
    wglDeleteContext(hRC);
}
//----------------------------------------------------------------------------
void TForm1::SetPixelFormatDescriptor()
{
       PIXELFORMATDESCRIPTOR pfd = {
    	sizeof(PIXELFORMATDESCRIPTOR),
        1,
        PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER,
        PFD_TYPE_RGBA,
        24,
        0,0,0,0,0,0,
        0,0,
        0,0,0,0,0,
        32,
        0,
        0,
        PFD_MAIN_PLANE,
        0,
        0,0,
    };

    int pixelformat;

    if ( (pixelformat = ChoosePixelFormat(hDC, &pfd)) == 0)
    {
        MessageBox(NULL, "Zle zvolen pixelformat", "Chyba", MB_OK);
        return ;
    }

    if (SetPixelFormat(hDC, pixelformat, &pfd) == false)
    {
        MessageBox(NULL, "Zle nastaven pixelformat", "Chyba", MB_OK);
        return ;
    }
}

//---------------------------------------------------------------------------

void TForm1::InitGL()
{

  glClearDepth(1.0f);
  glEnable(GL_DEPTH_TEST);              //nastavenie z-bufferu
  glDepthFunc(GL_LESS);

  glShadeModel(GL_SMOOTH);              //zapnutie tienovania
  glDisable(GL_CULL_FACE);

  glClearColor(0.0f, 0.0f, 0.0f, 0.0f);              //farba pozadia
  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);         //vykreslovanie polygonov

  glLineWidth(2.0f);                                 //hrubka ciary

  glEnable(GL_LINE_SMOOTH);                          //povolenie antialisingu

  glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, materialAmbient);    // nastavenie ambientnej zlozky farby materialu

 // glMaterialfv(GL_FRONT, GL_SPECULAR, materialSpecular);  // nastavenie farby odlesku
  glMaterialfv(GL_FRONT, GL_SHININESS, materialShininess);// nastavenie faktoru odlesku

  glLightfv(GL_LIGHT0, GL_POSITION, light_position);      // nastaveni pozice svetla
  glEnable(GL_LIGHTING);                                  // globalne povolenie tienovania
  glEnable(GL_LIGHT0);                                    // povolenie prveho svetla

  //textury
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);          // sposob ulozenia bytu v texure

  glGenTextures(3, textures);                     // vytvoreni jmena textur

  //nacitanie textur zo suborov
  if (bitmapLoad(textures[TEXTURE_TABLE],   "image/doska1.bmp")){
    MessageBox(0,"Nepodarilo sa nata sbor image/doska1.bmp","Form Create", MB_OK);
    exit(0);
    };
  if (bitmapLoad(textures[TEXTURE_GROUND],  "image/dlazkatm1.bmp")){
    MessageBox(0,"Nepodarilo sa nata sbor image/dlazkatm1.bmp","Form Create", MB_OK);
    exit(0);
    };
  if (bitmapLoad(textures[TEXTURE_SEAT],    "image/plocha1.bmp")){
    MessageBox(0,"Nepodarilo sa nata sbor image/plocha1.bmp","Form Create", MB_OK);
    exit(0);
    };

  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);    // nastavenie rezimu textury
  glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);               // korektne mapovanie textur
}

//---------------------------------------------------------------------------

void __fastcall TForm1::FormResize(TObject *Sender)
{
  DrawScene();
  zobraz_info();
}
//---------------------------------------------------------------------------

int round(float f)
{
  return floor(f+0.5);
}
//---------------------------------------------------------------------------

void TForm1::DrawScene(void)
{
    //zmazanie obrazovky
    glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

    glLoadIdentity();

    //nastavenie vzdialenosti a spravne natocenie telesa
    glTranslatef(0.0, 0.0, zoom);

    glRotatef(uhelX, 1.0, 0.0, 0.0);
    glRotatef(uhelY, 0.0, 1.0, 0.0);
    glRotatef(uhelZ, 0.0, 0.0, 1.0);

    /*
    //svetlo sa otaca spolu so stolom
    glPushMatrix();                             // ulozenie matice na zasobnik a zmena pozicie svetla
    glLightfv(GL_LIGHT0, GL_POSITION, light_position);
    glPopMatrix();
      */

    /*
    //vykreslenie suradnicovych osi
    glBegin(GL_LINES);
      glColor3f(1,1,1);
        glVertex3f(0.0,0.0,0.0);
        glVertex3f(5.0,0.0,0.0);
        glVertex3f(0.0,0.0,0.0);
        glVertex3f(0.0,5.0,0.0);
        glVertex3f(0.0,0.0,0.0);
        glVertex3f(0.0,0.0,5.0);
      glColor3f(0.2,0.2,0.2);
        glVertex3f(0.0,0.0,0.0);
        glVertex3f(-5.0,0.0,0.0);
        glVertex3f(0.0,0.0,0.0);
        glVertex3f(0.0,-5.0,0.0);
        glVertex3f(0.0,0.0,0.0);
        glVertex3f(0.0,0.0,-5.0);
    glEnd();
   */

    int i,j;
    bod sur;
    stolicka *st;

    //kreslenie aktualnej stolicky
    st=gp->stolicky[gp->akt];

    glTranslatef(0.0, -st->miny, 0.0);   //aby rovina dlazky bola vzdy na jednej pozicii na obrazovke

    for(i=0;i<st->length();i++)
      if(st->dlzky[i]>0)
        if(st->dlzky[i]<100){            //nakreslenie ciary

          glBegin(GL_LINE_STRIP);
            glColor3f(1.0f,1.0f,1.0f);
            for(j=0;j<st->dlzky[i];j++){
              sur=st->utvary[i][j];
              glVertex3f(sur.x,sur.y,sur.z);
              };
          glEnd();

        }
        else{                            //nakreslenie plochy

        glEnable(GL_TEXTURE_2D);                                // povolenie texturovania
        glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_REPLACE);
        glBindTexture(GL_TEXTURE_2D, textures[TEXTURE_SEAT]);   // naviazanie textury

        if(!st->stol && st->plocha_je_sedatko(i))               //ak to nie je stol a aktualna rovian je sedatko
           glBindTexture(GL_TEXTURE_2D, textures[TEXTURE_TABLE]);

          glBegin(GL_POLYGON);
            glColor3f(0,1,0);
            for(j=0;j<st->dlzky[i]-100;j++){
              sur=st->utvary[i][j];
              glTexCoord2f(0.0f,j);
              glVertex3f(sur.x,sur.y,sur.z);
              };
          glEnd();

          glDisable(GL_TEXTURE_2D);
        };

    //nakreslenie dosky stola
    glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D, textures[TEXTURE_TABLE]);   // navazani textury

     if(st->stol){

       if(st->symetria4){
         glBegin(GL_QUADS);
           glColor3f(0.0f,0.0f,0.0f);
           glNormal3f(0.0f,1.0f,0.0f);

           glTexCoord2f(0.0f,0.0f);
           glVertex3f(st->mox,st->maxy,st->moz);
           glTexCoord2f(1.0f,0.0f);
           glVertex3f(-st->mox,st->maxy,st->moz);
           glTexCoord2f(1.0f,1.0f);
           glVertex3f(-st->mox,st->maxy,-st->moz);
           glTexCoord2f(0.0f,1.0f);
           glVertex3f(st->mox,st->maxy,-st->moz);
         glEnd();
         };

       if(st->symetria){
         glBegin(GL_QUADS);
           glColor3f(0.0f,0.0f,0.0f);
           glNormal3f(0.0f,1.0f,0.0f);

           glTexCoord2f(0.0f,0.0f);
           glVertex3f(st->mox,st->maxy,st->maxz);
           glTexCoord2f(1.0f,0.0f);
           glVertex3f(-st->mox,st->maxy,st->maxz);
           glTexCoord2f(1.0f,1.0f);
           glVertex3f(-st->mox,st->maxy,st->minz);
           glTexCoord2f(0.0f,1.0f);
           glVertex3f(st->mox,st->maxy,st->minz);
         glEnd();
         };
       };

    glBindTexture(GL_TEXTURE_2D, textures[TEXTURE_GROUND]);

    //nakreslenie dlazky
    glBegin(GL_POLYGON);
      glColor3f(1.0f,0.0f,0.0f);
      glNormal3f(0.0f,1.0f,0.0f);

      glTexCoord2f(10.0f,10.0f);
      glVertex3f(-40.0f,st->miny,-40.0f);
      glTexCoord2f(0.0f,10.0f);
      glVertex3f(40.0f,st->miny,-40.0f);
      glTexCoord2f(0.0f,0.0f);
      glVertex3f(40.0f,st->miny,40.0f);
      glTexCoord2f(10.0f,0.0f);
      glVertex3f(-40.0f,st->miny,40.0f);
    glEnd();

    glDisable(GL_TEXTURE_2D);

    //nskreslenie bodky na mieste taziska objektu
    bod pom;
    pom=gp->stolicky[gp->akt]->tazisko();

    glBegin(GL_POINTS);
      glColor3f(1,0,0);
      glVertex3f(pom.x,pom.y,pom.z);
    glEnd();
}

//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
  // zru okno OpenGL
  wglDeleteContext(hRC);
  Form1->Visible=false;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  hDC=GetDC(Panel1->Handle);
  SetPixelFormatDescriptor();
  hRC = wglCreateContext(hDC);
  wglMakeCurrent(hDC, hRC);
  if (hRC == NULL) {
    MessageBox(0,"Nepodarilo sa vytvori Rendering Context!","Form Create", MB_OK);
    return;
  }
 
  nieco();
  InitGL();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Konec1Click(TObject *Sender)
{
Close();
}

//---------------------------------------------------------------------------

void __fastcall TForm1::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    //ovladanie rotacie pomocou klavesnice

    if(Key == 65)
       uhelX+=2;
    if(Key == 83)
        uhelX-=2;
    if(Key == 68)
        uhelY+=2;
    if(Key == 70)
        uhelY-=2;
    if(Key == 71)
        uhelZ+=2;
    if(Key == 72)
        uhelZ-=2;

  DrawScene();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::nextClick(TObject *Sender)
{
  //prechod na nasledujucu stolicku
  prev->Enabled=true;
  gp->akt+=1;
  if(gp->akt==gp->pocet-1)next->Enabled=false;
  uhelX=20;
  uhelZ=0;
  zoom=0;

  DrawScene();

  zobraz_info();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::prevClick(TObject *Sender)
{
  //prechod na predchadzajucu stolicku
  next->Enabled=true;
  gp->akt-=1;
  if(gp->akt==0)prev->Enabled=false;
  uhelX=20;
  uhelZ=0;
  zoom=0;

  DrawScene();

  zobraz_info();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::nieco()
{
  //nastavenie typu zobrazovania a velkosti okna, do ktoreho sa bude kreslit
  float gldAspect;

  gldAspect = Panel1->ClientWidth / Panel1->ClientHeight;

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(30.0,        //zorn uhel kamery                      //perspektivne zobrazovanie
                gldAspect,   // pomer vky a ky projeknho pltna
                0.1,         // nejmen vzdlenost, od kter je vidt objekt
                60.0);       // nejvt vzdlenost od kter u objekt vidt nen


  // glOrtho (-nRange, nRange, -nRange, nRange, -nRange, nRange);       //ortogonalne zobrazovanie
  glTranslatef(0,0,-30);             //pouzit len pri gluPerspective
  glViewport(0,0, Panel1->ClientWidth, Panel1->ClientHeight);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  glLightfv(GL_LIGHT0, GL_POSITION, light_position);        //nastavenie svetla
}

//---------------------------------------------------------------------------

void __fastcall TForm1::spustiClick(TObject *Sender)
{
  //spustenie evolucie
  int i, pom;
  FILE *sub;

 // sub=fopen("fitness.txt","a+");

  if(!TryStrToInt(Edit1->Text,pom)){
    Application->MessageBoxA("Nevhodn formt vyplnench dajov","Chyba",MB_OK);
    }
  else {

  for(i=0;i<StrToInt(Edit1->Text);i++){
    gp->generacia();
 //   fprintf(sub,"%f \n",gp->priemerna_fitness_celkova());      //zapisovanie priemernych hodnot celkovej fitness po generaciach
 //   gp->priem_fit_po_castiach();       //zapisovanie priemernych hodnot jednotlivych kriterii po generaciach do suboru
    Label7->Caption=gp->gen;
    Refresh();
    };

 // fclose(sub);

  Application->MessageBox("Hotovo","Hotovo",MB_OK);

  zobraz_info();
  };
}
//---------------------------------------------------------------------------

void __fastcall TForm1::zobraz_info()
{
  //aktualizacie udajov o aktualnej stolicke na informacnych formularoch
  if(Form1->Visible){

  Form1->Label7->Caption=gp->gen;
  Form1->Label9->Caption=gp->stolicky[gp->akt]->cislo;
  fitness->Caption=gp->stolicky[gp->akt]->fitness();
  if(Form3->Visible)Form3->aktualizuj(gp->stolicky[gp->akt]->nast,gp->stolicky[gp->akt]->hodn_fit);

  stolicka *st;
  int pom;

  st=gp->stolicky[gp->akt];
  pom=st->posuny->pocet_ploch;
  if(st->symetria)pom*=2;
  if(st->symetria4)pom*=4;
  if(Form5->Visible)Form5->aktualizuj(st->pocet_useciek,pom,st->stabilna(),st->je_sedatko(),st->fitness());
  };
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Uloz1Click(TObject *Sender)
{
  //ukladanie stolicky do suboru
  SaveDialog1->Title="Uloenie stoliky";
  SaveDialog1->DefaultExt="st";

  if(SaveDialog1->Execute()){
    gp->stolicky[gp->akt]->uloz_do_suboru(SaveDialog1->FileName);
    };
}

//---------------------------------------------------------------------------

void __fastcall TForm1::IdleLoop(TObject* Sender, bool &Done)
{
  Done = true;
  SwapBuffers(hDC); // openGL call
}

//---------------------------------------------------------------------------

void __fastcall TForm1::Otvor1Click(TObject *Sender)
{
  //nacitanie stollicky zo suboru
  OpenDialog1->Title="Otvorenie stoliky";

  if(OpenDialog1->Execute()){
    delete gp;
    gp=new prostr(1);
    gp->stolicky[gp->akt]->nacitaj_zo_suboru(OpenDialog1->FileName);

    DrawScene();

    zobraz_info();
    next->Enabled=false;
    prev->Enabled=false;
    zaciatok->Enabled=false;
    spusti->Enabled=false;
    };
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Novapopulacia2Click(TObject *Sender)
{
  //zrusenie starej populacie a vytvorenie novej
  delete gp;

  TIniFile *ini;
   
  ini = new TIniFile(ChangeFileExt(Application->ExeName,".INI"));

  gp=new prostr(ini);       //nacita nastavenia ako su ulozene v ini subore a vytvori populaciu

  delete ini;

  DrawScene();

  zobraz_info();

  if(gp->akt==0)prev->Enabled=false;
  if(gp->pocet-1==gp->akt)next->Enabled=false;
  else next->Enabled=true;

  zaciatok->Enabled=true;
  spusti->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::zaciatokClick(TObject *Sender)
{
  //preskocenie na prvu stolicku v populacii
  next->Enabled=true;
  gp->akt=0;
  if(gp->akt==0)prev->Enabled=false;
  uhelX=20;
  uhelY=0;
  uhelZ=0;
  DrawScene();
  zobraz_info();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Nastavenia2Click(TObject *Sender)
{
  //zobrazenie formulara na nastavovanie fitness
  Form2->Visible=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Podrobnosti1Click(TObject *Sender)
{
  //zobrazenie formulara s podrobnostami o hodnotach fitness pre aktualnu stolicku
  Form3->Visible=true;
  Form3->aktualizuj(gp->stolicky[gp->akt]->nast,gp->stolicky[gp->akt]->hodn_fit);
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Nastavenie1Click(TObject *Sender)
{
  //zobrazenie formulara s podrobnostami o stolicke
  Form4->Visible=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  //automaticka rotacia objektu
  uhelY+=2;
  DrawScene();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Podrobnosti2Click(TObject *Sender)
{
  //zobrazenie podrobnych udajov o aktualnej stolicke
  int pom;
  stolicka *st;

  st=gp->stolicky[gp->akt];
  pom=st->posuny->pocet_ploch;
  if(st->symetria)pom*=2;
  if(st->symetria4)pom*=4;
  Form5->Visible=true;
  Form5->aktualizuj(st->pocet_useciek,pom,st->stabilna(),st->je_sedatko(),st->fitness());
}
//---------------------------------------------------------------------------

void __fastcall TForm1::zoomplusClick(TObject *Sender)
{
  zoom+=1;
  DrawScene();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::zoomminusClick(TObject *Sender)
{
  zoom-=1;
  DrawScene();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::rotujplusClick(TObject *Sender)
{
  uhelX+=2;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::rotujminusClick(TObject *Sender)
{
  uhelX-=2;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  gp->stolicky[gp->akt]->mutuj();        
}
//---------------------------------------------------------------------------

