//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "deklaracie.h"
#include "genpr.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

prostr::prostr(int poc)
{
  int i;

  pocet=poc;
  akt=0;
  poc_novych=0;
  gen=0;

  for(i=0;i<pocet;i++){
    stolicky[i]= new stolicka((i+1)*45);
    stolicky[i]->napln_nahodne();
    stolicky[i]->cislo=i;
    };

  for(i=0;i<pocet;i++)
    nove[i]=NULL;
}

prostr::prostr(TIniFile *ini)
{
  bool sym,sym2,sym4,tab;

  nast.stabilita_stola=ini->ReadBool("Stol","Checked",false);
  nast.stab_nohy=ini->ReadBool("Stol","Nohy_checked",false);
  nast.stab_doska=ini->ReadBool("Stol","Doska_checked",false);
  nast.stab_noh_hodn=ini->ReadInteger("Stol","Nohy_hodn",0);
  nast.stab_dos_hodn=ini->ReadInteger("Stol","Doska_hodn",0);

  nast.pocet_ploch=ini->ReadBool("Poc_ploch","Checked",false);
  nast.poc_plo_min=ini->ReadBool("Poc_ploch","Min_checked",false);
  nast.poc_plo_max=ini->ReadBool("Poc_ploch","Max_checked",false);
  nast.poc_plo_min_hodn=ini->ReadInteger("Poc_ploch","Min_hodn",0);
  nast.poc_plo_min_penal=ini->ReadInteger("Poc_ploch","Min_penal",0);
  nast.poc_plo_max_hodn=ini->ReadInteger("Poc_ploch","Max_hodn",0);
  nast.poc_plo_max_penal=ini->ReadInteger("Poc_ploch","Max_penal",0);

  nast.pocet_ciar=ini->ReadBool("Poc_ciar","Checked",false);
  nast.poc_ciar_min=ini->ReadBool("Poc_ciar","Min_checked",false);
  nast.poc_ciar_max=ini->ReadBool("Poc_ciar","Max_checked",false);
  nast.poc_ciar_min_hodn=ini->ReadInteger("Poc_ciar","Min_hodn",0);
  nast.poc_ciar_min_penal=ini->ReadInteger("Poc_ciar","Min_penal",0);
  nast.poc_ciar_max_hodn=ini->ReadInteger("Poc_ciar","Max_hodn",0);
  nast.poc_ciar_max_penal=ini->ReadInteger("Poc_ciar","Max_penal",0);

  nast.sedatko=ini->ReadBool("Sedatko","Checked",false);
  nast.sedatko_rovnost=ini->ReadBool("Sedatko","Rovnost",false);
  nast.sedatko_vyska=ini->ReadBool("Sedatko","Vyska",false);
  nast.sedatko_stabilita=ini->ReadBool("Sedatko","Stabilita",false);
  nast.sed_rov_hodn=ini->ReadInteger("Sedatko","Rov_hodn",0);
  nast.sed_vys_hodn=ini->ReadInteger("Sedatko","Vys_hodn",0);
  nast.sed_vys_min_hodn=ini->ReadInteger("Sedatko","Vys_min_hodn",0);
  nast.sed_vys_max_hodn=ini->ReadInteger("Sedatko","Vys_max_hodn",0);
  nast.sed_sta_hodn=ini->ReadInteger("Sedatko","Sta_hodn",0);

  nast.stabilita=ini->ReadBool("Stabilita","Checked",false);
  nast.stabilita_hodn=ini->ReadInteger("Stabilita","hodn",0);

  pocet=ini->ReadInteger("Velkost_pop","Pocet",100);

  sym=ini->ReadBool("Symetria","Checked",false);
  sym2=ini->ReadBool("Symetria","2nasobna symetria",false);
  sym4=ini->ReadBool("Symetria","4nasobna symetria",false);
  tab=ini->ReadBool("Stol","Doska",false);

  if(!sym){
    sym2=false;
    sym4=false;
    };

  int i;

  akt=0;
  poc_novych=0;
  gen=0;

  for(i=0;i<pocet;i++){
    stolicky[i]= new stolicka(nast,sym2,sym4,tab);
    stolicky[i]->napln_nahodne();
    stolicky[i]->cislo=i;
    };

  for(i=0;i<pocet;i++)
    nove[i]=NULL;
}

prostr::~prostr()
{
  int i;

  for(i=0;i<pocet;i++)
    delete stolicky[i];

}

void prostr::prekriz(int st1, int st2)
{
  prvok *pom;

  if((nove[st1]==NULL) || (nove[st2]==NULL)){
    Application->MessageBox("Chyba v kren","Chyba",MB_OK);
    abort();
    };
  if((st1<0) || (st2<0) || (st1>poc_novych) || (st2>poc_novych) || (poc_novych>1005)){
    Application->MessageBox("Chyba v kren","Chyba",MB_OK);
    abort();
    };

  pom=nove[st1]->daj_na_krizenie();
  nove[st1]->pridaj_pri_krizeni(nove[st2]->daj_na_krizenie());
  nove[st2]->pridaj_pri_krizeni(pom);
}

int prostr::min_fit()
{
  int i;
  int min=100;
  int pozmin=-1;

  if(pocet==0)return -1; //??

  for(i=0;i<pocet;i++)
    if(stolicky[i]->fitness()<min){
      min=stolicky[i]->fitness();
      pozmin=i;
      };

  return pozmin;
}

int prostr::max_fit()
{
  int i;
  int max=0;

  for(i=0;i<pocet;i++)
    if(stolicky[i]->fitness()>max)
      max=stolicky[i]->fitness();

  return max;
}

void prostr::generacia()
{
  int p1,p2,rodic1,rodic2;
  int i;

  for(i=0;i<pocet/2;i++){
    rodic1=0;
    rodic2=0;

    while(rodic1==rodic2){
      //vyber prveho rodica
      p1=random(pocet);
      p2=random(pocet);
      rodic1=p1;
      if(stolicky[p1]->fitness()<stolicky[p2]->fitness())
        rodic1=p2;

      //vyber druheho rodica
      p1=random(pocet);
      p2=random(pocet);
      rodic2=p1;
      if(stolicky[p1]->fitness()<stolicky[p2]->fitness())
        rodic2=p2;
      };

    nove[poc_novych]=stolicky[rodic1]->zduplikuj_sa();
    nove[poc_novych+1]=stolicky[rodic2]->zduplikuj_sa();

    poc_novych+=2;

    //opravit cislo pri zmene maximalneho poctu stoliciek v populacii
    if(poc_novych>1000){
      Application->MessageBox("Vea novch stoliiek","Chyba",MB_OK);
      abort();
      };

    prekriz(poc_novych-2,poc_novych-1);

    nove[poc_novych-2]->mutuj();
    nove[poc_novych-1]->mutuj();
    };

  THeapStatus pam;

  //zmazanie starych stoliciek
  pam=GetHeapStatus();

  for(i=0;i<pocet;i++)
    delete stolicky[i];

  pam=GetHeapStatus();

  //prekopirovanie novych stoliciek

  for(i=0;i<poc_novych;i++){
    stolicky[i]=nove[i];
    stolicky[i]->cislo=i;
    nove[i]=NULL;
    };

  pocet=poc_novych;
  gen+=1;
  poc_novych=0;
}

int prostr::pocet_lepsich_ako(int x)
{
  int i;
  int suma=0;

  for(i=0;i<pocet;i++)
    if(stolicky[i]->fitness()>x)suma+=1;

  return suma;  
}

float prostr::priemerna_fitness_celkova()
{
  float pom=0;
  int i;

  for(i=0;i<pocet;i++)
    pom+=stolicky[i]->fitness();

  return pom/pocet;
}

void prostr::priem_fit_po_castiach()
{
  FILE *sub;
  int i;
  float pomstab=0;
  float pomsedr=0;
  float pomsedst=0;
  float pomsedv=0;
  float pomstdos=0;
  float pomstnoh=0;

  sub=fopen("fit_casti.txt","a+");

  for(i=0;i<pocet;i++){
    pomstab+=stolicky[i]->hodn_fit.stabilita;
    pomsedr+=stolicky[i]->hodn_fit.sed_rovnost;
    pomsedst+=stolicky[i]->hodn_fit.sed_stabilita;
    pomsedv+=stolicky[i]->hodn_fit.sed_vyska;
    pomstdos+=stolicky[i]->hodn_fit.stol_doska;
    pomstnoh+=stolicky[i]->hodn_fit.stol_nohy;
    };

  pomstab/=pocet;
  pomsedr/=pocet;
  pomsedst/=pocet;
  pomsedv/=pocet;
  pomstdos/=pocet;
  pomstnoh/=pocet;

  fprintf(sub,"%f\t%f\t%f\t%f\t%f\t%f\n",pomstab,pomsedr,pomsedst,pomsedv,pomstdos,pomstnoh);  

  fclose(sub);
}
