//---------------------------------------------------------------------------

#ifndef maticaH
#define maticaH
//---------------------------------------------------------------------------
/**
 * Jednoducha trieda na zakladne operacie s maticou 3x3.
 */ 
class matica{
 public:
  /**
   * Hodnoty prvkov matici
   */ 
  float data[3][3];
  
 public:
  /**
   * Konstruktor.
   * vyrobi maticu a naplni ju po riadkoch hodnotami zo vstupu
   * @param *vstup pointer na pole 9 hodnot
   */ 
  matica(float *vstup);

  /**
   * Konstruktor.
   * vyrobi nulovu maticu
   */ 
  matica();

  /**
   * Vynasobi maticu skalarom
   * @param x skalar, ktorym sa bude nasobit matica
   */
  void vynasob(float x);  //nasobenie matice skalarom x

  /**
   * Nasobenie matice inou maticou sprava
   * @param *a matica, ktorou sa nasobi
   * @return matica, vysledok nasobenia
   */ 
  matica* vynasob_sprava(matica *a);  //matica bude vynasobena maticou a sprava

  /**
   * Vynasobenie matice vektorom
   * @param v vektor, ktorym sa nasobi
   * @return vektor, vysledok nasobenia
   */
  vektor vynasob_vektorom(vektor v);

  /**
   * Vypocita determinant matice
   * @return hodnota determinantu
   */
  float determinant();
};

#endif
