//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "stolicka.h"
#include "zoznam.h"
#include <math.h>
#include <stdio.h>
//---------------------------------------------------------------------------

#pragma package(smart_init)

int round(float f)
{
  return floor(f+0.5);
}
//---------------------------------------------------------------------------

stolicka::stolicka(int uhol)
//vygeneruje nahodnu stolicku
{
  int i,j, pocet;

  posuny=new strom();

  fit=-1;
  stabilita=-1;
 // pocet=random(3)+2;
  cislo=0;
  miny=100;
  maxy=-100;
  mox=0;
  moz=0;  
  pocet_bodov=0;
  pocet_sedatok=0;
  pocet_useciek=0;
  stol=false;

  zaciatok.x=0;
  zaciatok.y=0;
  zaciatok.z=0;
}
//---------------------------------------------------------------------------

stolicka::stolicka(nastavenie_fitness n,bool sym,bool sym4,bool doska)
{
  nast=n;
  symetria=sym;
  symetria4=sym4;
  stol=doska;

  posuny=new strom();

  fit=-1;
  stabilita=-1;
  cislo=0;
  miny=100;
  maxy=-100;
  mox=0;
  moz=0;
  pocet_bodov=0;
  pocet_sedatok=0;
  pocet_useciek=0;

  zaciatok.x=0;
  zaciatok.y=0;
  zaciatok.z=0;
}
//---------------------------------------------------------------------------

void stolicka::napln_nahodne()
{
  posuny->napln_nahodne();
  vyrataj_body();
}
//---------------------------------------------------------------------------

stolicka::~stolicka()
{
  delete posuny;
}
//---------------------------------------------------------------------------

void stolicka::vyrataj_body()
//vypocita suradnice vsetkych bodov stolicky
{
  int* pomint;
  bod* pombod;
  int i,j,poc_zaz,pom,poc;

  //nacitanie pola dlzky
  pomint=posuny->vrat_dlzky();
  poc_zaz=posuny->pocet_zaznamov;
  for(i=0;i<poc_zaz;i++){
    dlzky[i]=*pomint;
    pomint++;
    };

  //nacitanie pola utvary
  pombod=posuny->vrat_utvary();
  for(i=0;i<poc_zaz;i++){
    for(j=0;j<30;j++){      //treba precitat vsetkych 30 poloziek, aby sme sa korektne dostali k dalsiemu polu
      utvary[i][j]=*pombod;
      pombod++;
      };
    };

  pocet_bodov=0;
  pocet_useciek=0;

  //nastavenie hodnot pocet_bodov a pocet_useciek
  for(i=0;i<poc_zaz;i++)
    if(dlzky[i]<100){              //ak je to ciara
      pocet_bodov+=dlzky[i];
      pocet_useciek+=dlzky[i];
      }
    else pocet_bodov+=dlzky[i]-100;     //ak je to rovina

  if(pocet_bodov>200){
    Application->MessageBox("Vea bodov v stolike","Chyba",MB_OK);
    abort();
    };

  if(symetria){
    if(poc_zaz*2>99){
      Application->MessageBox("Vea zznamov v stolike","Chyba v symetrii",MB_OK);
      abort();
      };
    };

  if(symetria4){
    if(poc_zaz*4>99){
      Application->MessageBox("Vea zznamov v stolike","Chyba v symetrii4",MB_OK);
      abort();
      };
    };
 
  zniz_body();

  if(symetria)urob_symetriu();
  if(symetria4)urob_4symetriu();

  vyrataj_oporne_body();

  najdi_sedatka();
}
//---------------------------------------------------------------------------

void stolicka::urob_symetriu()
{
  //zduplikuje vsetky body a spravi z nich zrkadlovo symetricke
  int i,j,poc,poc_zaz;

  poc_zaz=posuny->pocet_zaznamov;

  //zduplikujeme vsetky zaznamy v poli utvary
  for(i=0;i<poc_zaz;i++){
    dlzky[i+poc_zaz]=dlzky[i];
    poc=dlzky[i];
    if(dlzky[i]>100)poc-=100;

    for(j=0;j<poc;j++){
      utvary[i+poc_zaz][j]=utvary[i][j];
      utvary[i+poc_zaz][j].x=-utvary[i+poc_zaz][j].x;    //zmena jedne suradnice = zrkadlenie
      };
    };

  pocet_bodov*=2;
  pocet_useciek*=2;
}
//---------------------------------------------------------------------------

void stolicka::urob_4symetriu()
{
  //ku kazdemu bodu vyrobi tri dalsie a zmeni ich suradnice tak, aby bol symetricke podla dvoch rovin
  int i,j,poc,poc_zaz;

  poc_zaz=posuny->pocet_zaznamov;

  //zduplikujeme vsetky zaznamy v poli utvary
  for(i=0;i<poc_zaz;i++){
    dlzky[i+poc_zaz]=dlzky[i];
    dlzky[i+2*poc_zaz]=dlzky[i];
    dlzky[i+3*poc_zaz]=dlzky[i];
    poc=dlzky[i];
    if(dlzky[i]>100)poc-=100;

    for(j=0;j<poc;j++){
      utvary[i+poc_zaz][j]=utvary[i][j];
      utvary[i+poc_zaz][j].x=-utvary[i+poc_zaz][j].x;
      utvary[i+2*poc_zaz][j]=utvary[i][j];
      utvary[i+2*poc_zaz][j].z=-utvary[i+2*poc_zaz][j].z;
      utvary[i+3*poc_zaz][j]=utvary[i+poc_zaz][j];
      utvary[i+3*poc_zaz][j].z=-utvary[i+3*poc_zaz][j].z;
      };
    };

  pocet_bodov*=4;
  pocet_useciek*=4;
}
//---------------------------------------------------------------------------

void stolicka::zniz_body()
{
  //znizuje potrebne mnoztvo bodov na uroven najnizsieho bodu v stolicke
  bod pombod;
  bod *p1, *p2, *p3;          //p1.y<p2.y<p3.y
  int i,j,poc;

  pombod.x=0;
  pombod.y=100;
  pombod.z=0;

  p1=&pombod;
  p2=&pombod;
  p3=&pombod;

  maxy=-100;
  minz=100;
  maxz=-100;
  mox=0;
  moz=0;

  //najdenie najnizsieho bodu
  for(i=0;i<posuny->pocet_zaznamov;i++){

    if(dlzky[i]<100)poc=dlzky[i];
    else poc=dlzky[i]-100;

    for(j=0;j<poc;j++){

      if(utvary[i][j].y<p1->y){
        p3=p2;
        p2=p1;
        p1=&utvary[i][j];
        }
      else if(utvary[i][j].y<p2->y){
             p3=p2;
             p2=&utvary[i][j];
             }
           else if(utvary[i][j].y<p3->y)
                  p3=&utvary[i][j];

      //nastavenie pomocnych premennych
      if(utvary[i][j].y>maxy){
        maxy=utvary[i][j].y;
        maxy_bod=utvary[i][j];
        };
      if(fabs(utvary[i][j].x)>mox)mox=fabs(utvary[i][j].x);
      if(fabs(utvary[i][j].z)>moz)moz=fabs(utvary[i][j].z);
      if(utvary[i][j].z<minz)minz=utvary[i][j].z;
      if(utvary[i][j].z>maxz)maxz=utvary[i][j].z;
      };
    };

  //dame vsetky tri na uroven toho najnizsieho, ak je stolicka symetricka, staci najnizsie 2
  //ak je stolicka  dvojnasobne symetricka, tak netreba nic znizovat
  if(!symetria&&!symetria4)p3->y=p1->y;
  if(!symetria4)p2->y=p1->y;
  miny=p1->y;
}
//---------------------------------------------------------------------------

void stolicka::vyrataj_oporne_body()
{
  int i,j;
  int poc,poc_zaz;

  //najdeme body, ktore nie su moc vysoko nad minimom a skopirujeme ich do pola opor_body
  pocmin=0;
  poc_zaz=posuny->pocet_zaznamov;
  if(symetria)poc_zaz*=2;
  if(symetria4)poc_zaz*=4;

  for(i=0;i<poc_zaz;i++){

    if(dlzky[i]<100)poc=dlzky[i];
    else poc=dlzky[i]-100;

    for(j=0;j<poc;j++)
      if((utvary[i][j].y-miny)<0.5){      //ak bod nie je prilis vysoko nad zemou
        opor_body[pocmin]=utvary[i][j];
        pocmin+=1;
        if(pocmin>99){
          Application->MessageBox("Vea opornch bodov","Chyba",MB_OK);
          abort();
          };
        };
    };
}
//---------------------------------------------------------------------------

void stolicka::mutuj()
{
  posuny->mutuj_strom();

  vyrataj_body();
}
//---------------------------------------------------------------------------

bod stolicka::tazisko()
{
  //tazisko sa rata ako vazeny priemer stredov useciek, vaha usecky je jej dlzka
  bod pom;
  int i,j,poc,suma1,suma2,poc_zaz;
  float sucet;
  float dlz[500];
  bod stredy[500];

  pom.x=0;
  pom.y=0;
  pom.z=0;

  if(posuny->is_empty()){
    pom.x=0;
    pom.y=0;
    pom.z=0;
    return pom;
    };

  suma1=0;     //na vyratanie stredov vsetkych stran, pocet doteraz spracovanych stran, pocet prvkov v poli stredy
  suma2=0;     //pocet prvkov v poli dlz
  sucet=0;

  poc_zaz=posuny->pocet_zaznamov;
  if(symetria)poc_zaz*=2;
  if(symetria4)poc_zaz*=4;

  for(i=0;i<poc_zaz;i++){

    if(dlzky[i]<100)poc=dlzky[i];
    else poc=dlzky[i]-100;

    //pocitanie stredov useciek
    for(j=0;j<poc-1;j++){
      if(suma1>499){
        Application->MessageBox("Vea bodov v poli stredy pri vpote aiska","Chyba1",MB_OK);
        abort();
        };
      stredy[suma1].x=(utvary[i][j].x+utvary[i][j+1].x)/2;
      stredy[suma1].y=(utvary[i][j].y+utvary[i][j+1].y)/2;
      stredy[suma1].z=(utvary[i][j].z+utvary[i][j+1].z)/2;
      suma1+=1;
      };
    //ak je to rovina, treba spracovat aj fyzicky neexistujucu ciaru z posledneho vrchola na zaciatok
    if(dlzky[i]>100){
      if(suma1>499){
        Application->MessageBox("Vea bodov v poli stredy pri vpote aiska","Chyba2",MB_OK);
        abort();
        };
      stredy[suma1].x=(utvary[i][0].x+utvary[i][poc-1].x)/2;
      stredy[suma1].y=(utvary[i][0].y+utvary[i][poc-1].y)/2;
      stredy[suma1].z=(utvary[i][0].z+utvary[i][poc-1].z)/2;
      suma1+=1;
      };

    float pom1,pom2;

    //pocitanie vah useciek
    for(j=0;j<poc-1;j++){
      pom1=(utvary[i][j].x-utvary[i][j+1].x)*(utvary[i][j].x-utvary[i][j+1].x)+
           (utvary[i][j].y-utvary[i][j+1].y)*(utvary[i][j].y-utvary[i][j+1].y)+
           (utvary[i][j].z-utvary[i][j+1].z)*(utvary[i][j].z-utvary[i][j+1].z);
      if(pom1<0)
        pom1=0;

      if(suma2>499){
        Application->MessageBox("Vea bodov v poli dlz pri vpote aiska","Chyba1",MB_OK);
        abort();
        };
      dlz[suma2]=sqrt(pom1);
      sucet+=dlz[suma2];
      suma2+=1;
      };
    if(dlzky[i]>100){
      pom2=(utvary[i][0].x-utvary[i][poc-1].x)*(utvary[i][0].x-utvary[i][poc-1].x)+
           (utvary[i][0].y-utvary[i][poc-1].y)*(utvary[i][0].y-utvary[i][poc-1].y)+
           (utvary[i][0].z-utvary[i][poc-1].z)*(utvary[i][0].z-utvary[i][poc-1].z);
      if(pom2<0)
       pom2=0;

      if(suma2>499){
        Application->MessageBox("Vea bodov v poli dlz pri vpocte aiska","Chyba2",MB_OK);
        abort();
        };
      dlz[suma2]=sqrt(pom2);
      sucet+=dlz[suma2];
      suma2+=1;
      };
    };

  //vypocet taziska zo ziskanych udajov
  pom.x=0;
  pom.y=0;
  pom.z=0;

  for(j=0;j<suma1;j++){
    pom.x+=stredy[j].x*dlz[j];
    pom.y+=stredy[j].y*dlz[j];
    pom.z+=stredy[j].z*dlz[j];
    };

  pom.x/=sucet;
  pom.y/=sucet;
  pom.z/=sucet;

  if(sucet<eps)return zaciatok;

  return pom;
}
//---------------------------------------------------------------------------

bool stolicka::je_sedatko()
{
  return pocet_sedatok>0;
}
//---------------------------------------------------------------------------

void stolicka::najdi_sedatka()
{
  //hlada priblizne vodorovne plochy, t.j. plocha, ktorej najvyssi a najnizsi bod nie su od seba vzdialenejsie viac ako 1 (co sa tyka vysky)
  int i,j,poc_zaz;
  float min,max;

  min=100;
  max=-100;

  poc_zaz=posuny->pocet_zaznamov;
  if(symetria)poc_zaz*=2;
  if(symetria4)poc_zaz*=4;

  for(i=0;i<poc_zaz;i++){
    if(dlzky[i]>100){
      min=100;
      max=-100;
      for(j=0;j<dlzky[i]-100;j++){
        if(utvary[i][j].y>max)max=utvary[i][j].y;
        if(utvary[i][j].y<min)min=utvary[i][j].y;
        };
      if((max-min<1)){      //ak je to sedadlo
        sedatka[pocet_sedatok]=i;
        pocet_sedatok+=1;
        if(pocet_sedatok>99){
          Application->MessageBox("Prli vea sedtok","Chyba",MB_OK);
          abort();
          };
        };
      };
    };
}
//---------------------------------------------------------------------------

float stolicka::fitness_za_sedatka()
{
  int i,j;
  float min,vys,fit1,fit2,max,vzd;
  konv_obal *obal2;

  max=-100; //na najdenie maximalnej fitness

  for(i=0;i<pocet_sedatok;i++){
    fit1=0;
    fit2=0;
    if(nast.sedatko_vyska){      //zistime fitness za vysku sedatka
      min=100;

      for(j=0;j<dlzky[sedatka[i]]-100;j++)
        if(utvary[sedatka[i]][j].y<min)min=utvary[sedatka[i]][j].y;

      vys=min-miny;         //vyska sedatka nad zemou

      if(vys<eps)fit2=0;
      else
        if(vys<nast.sed_vys_min_hodn){                //vyska je nizsia ako pozadovana
          fit1=vys*nast.sed_vys_hodn/nast.sed_vys_min_hodn;
          }
        else
          if(vys<nast.sed_vys_max_hodn){              //vyska je v intervale
            fit1=nast.sed_vys_hodn;
            }
            else fit1=(vys-nast.sed_vys_max_hodn)*nast.sed_vys_hodn/(10-nast.sed_vys_max_hodn);   //vyska je nad intervalom
      };

    if(nast.sedatko_stabilita){
      vzd=vzdialenost_bodov_bez_y(tazisko_roviny(sedatka[i]),tazisko_opor_bodov());
      fit2=nast.sed_sta_hodn*(-1/10.0*vzd+1);
     };

    //hladame sedadlo s maximalnou hodnotou fitness za sucet kriterii
    if(fit1+fit2>max){
      max=fit1+fit2;
      hodn_fit.sed_vyska=fit1;
      hodn_fit.sed_stabilita=fit2;
      };
    };

  return max;
}
//---------------------------------------------------------------------------

float stolicka::fitness()
{
  float plocha_stola;
  float pom, pomx, pomz;
  int i;

 // if(fit>-1)return fit;

  fit=0.0;
  hodn_fit.pocet_rovin=0;
  hodn_fit.pocet_useciek=0;
  hodn_fit.stol_doska=0;
  hodn_fit.stol_nohy=0;
  hodn_fit.sed_rovnost=0;
  hodn_fit.sed_stabilita=0;

  if(posuny->is_empty())return 0;

  if(nast.stabilita)
    if(stabilna()){
      hodn_fit.stabilita=nast.stabilita_hodn;     //stabilita
      fit+=hodn_fit.stabilita;
      };

  if(nast.sedatko){
    if(nast.sedatko_rovnost)
      if(je_sedatko()){
        hodn_fit.sed_rovnost=nast.sed_rov_hodn;        //ak je v stolicke nejake sedatko
        fit+=hodn_fit.sed_rovnost;
        }
      else hodn_fit.sed_rovnost=0;  
    if(pocet_sedatok>0)fit+=fitness_za_sedatka();
    else {
      hodn_fit.sed_vyska=0;
      hodn_fit.sed_stabilita=0;
      };
    };

  if(nast.pocet_ciar){
    if(nast.poc_ciar_min){
      if(pocet_useciek<=nast.poc_ciar_min_hodn)    //ak je pocet ciar mensi ako zadane minimum
        hodn_fit.pocet_useciek+=(nast.poc_ciar_min_hodn-pocet_useciek)*nast.poc_ciar_min_penal;
      };
    if(nast.poc_ciar_max){
      if(pocet_useciek>=nast.poc_ciar_max_hodn)    //ak je pocet ciar vacsi ako zadane maximum
        hodn_fit.pocet_useciek+=(pocet_useciek-nast.poc_ciar_max_hodn)*nast.poc_ciar_max_penal;
      };
    fit+=hodn_fit.pocet_useciek;
    };

  if(nast.pocet_ploch){
    if(nast.poc_plo_min)
      if(posuny->pocet_ploch<=nast.poc_plo_min_hodn)    //ak je pocet ploch mensi ako zadane minimum
        hodn_fit.pocet_rovin+=(nast.poc_plo_min_hodn-posuny->pocet_ploch)*nast.poc_plo_min_penal;
    if(nast.poc_plo_max)
      if(posuny->pocet_ploch>=nast.poc_plo_max_hodn)    //ak je pocet ploch vacsi ako zaadne maximum
        hodn_fit.pocet_rovin+=(posuny->pocet_ploch-nast.poc_plo_max_hodn)*nast.poc_plo_max_penal;
    fit+=hodn_fit.pocet_rovin;
    };

  if(nast.stabilita_stola&&symetria4){         //kriterium ma zmysel len pri stoloch
    plocha_stola=4*mox*moz;                    //plocha dosky stola
    if(nast.stab_doska){
      pom=4*fabs(maxy_bod.x*maxy_bod.z);       //plocha urcena bodmi, o ktore sa opiera doska stola
      if(pom>plocha_stola/9)hodn_fit.stol_doska=nast.stab_dos_hodn;
      else hodn_fit.stol_doska=pom/(plocha_stola/9)*nast.stab_dos_hodn;
      fit+=hodn_fit.stol_doska;
      };
    if(nast.stab_nohy){

      //najdeme od stredu najvzdialenejsi oporny bod (maximalnu excentricitu oporneho bodu)
      pomx=-100;
      pomz=-100;

      for(i=0;i<pocmin;i++){
        if(fabs(opor_body[i].x)>pomx)pomx=fabs(opor_body[i].x);
        if(fabs(opor_body[i].z)>pomz)pomz=fabs(opor_body[i].z);
        };

      pom=4*pomx*pomz;     //plocha urcena opornymi bodmi stola
      if(pom>plocha_stola/2)hodn_fit.stol_nohy=nast.stab_noh_hodn;
      else hodn_fit.stol_nohy=pom/(plocha_stola/2)*nast.stab_noh_hodn;
      fit+=hodn_fit.stol_nohy;
      };
    };    

  return fit;
}
//---------------------------------------------------------------------------

prvok* stolicka::daj_na_krizenie()
{
  //vyberie nahodny kus zoznamu od seba a ponukne ho na krizenie
  prvok *pom;
  zoznam *zoz;

  zoz=posuny->zoznam_na_krizenie();

  pom=zoz->kus_zoznamu();

  return pom;
}
//---------------------------------------------------------------------------

void stolicka::pridaj_pri_krizeni(prvok *uk)
{
  //prida po krizeni zoznam na miesto, skade bola predtym odobrata ina cast zoznamu
  posuny->pridaj_po_krizeni(uk);
  pocet_sedatok=0;
  pocet_useciek=0;
  vyrataj_body();
  fit=-1;
}
//---------------------------------------------------------------------------

bool stolicka::stabilna()
{
  //zistuje, ci je stolicka stabilna
  int i;
  konv_obal *obal;
  bool result=false;
  bod pom;

  if(pocmin<3)return false;

  //vytvorime konvexny obal opornych bodov
  obal=new konv_obal();

  for(i=0;i<pocmin;i++)
    obal->pridaj(opor_body[i]);

  pom=tazisko();

  //zistime, ci sa tazisko nachadza nad konvexnym obalom opornych bodov
  result=obal->je_vnutri(pom);

  delete obal;

  return result;
}
//---------------------------------------------------------------------------

bod stolicka::tazisko_roviny(int x)
{
  //pocita tazisko roviny ulozenej v utvary[x]
  float sucet,pom1;
  float dlz[30];
  bod stredy[30];
  int poc,j;
  bod pom;

  poc=dlzky[x]-100;
  sucet=0;

  for(j=0;j<poc-1;j++){
    stredy[j].x=(utvary[x][j].x+utvary[x][j+1].x)/2;
    stredy[j].y=(utvary[x][j].y+utvary[x][j+1].y)/2;
    stredy[j].z=(utvary[x][j].z+utvary[x][j+1].z)/2;
    };

  stredy[poc-1].x=(utvary[x][0].x+utvary[x][poc-1].x)/2;
  stredy[poc-1].y=(utvary[x][0].y+utvary[x][poc-1].y)/2;
  stredy[poc-1].z=(utvary[x][0].z+utvary[x][poc-1].z)/2;

  for(j=0;j<poc-1;j++){
    pom1=(utvary[x][j].x-utvary[x][j+1].x)*(utvary[x][j].x-utvary[x][j+1].x)+
         (utvary[x][j].y-utvary[x][j+1].y)*(utvary[x][j].y-utvary[x][j+1].y)+
         (utvary[x][j].z-utvary[x][j+1].z)*(utvary[x][j].z-utvary[x][j+1].z);
    if(pom1<0)
    pom1=0;

    dlz[j]=sqrt(pom1);
    sucet+=dlz[j];
    };

  pom1=(utvary[x][0].x-utvary[x][poc-1].x)*(utvary[x][0].x-utvary[x][poc-1].x)+
       (utvary[x][0].y-utvary[x][poc-1].y)*(utvary[x][0].y-utvary[x][poc-1].y)+
       (utvary[x][0].z-utvary[x][poc-1].z)*(utvary[x][0].z-utvary[x][poc-1].z);
  if(pom1<0)
    pom1=0;
  dlz[poc-1]=sqrt(pom1);
  sucet+=dlz[poc-1];

  pom.x=0;
  pom.y=0;
  pom.z=0;

  for(j=0;j<poc;j++){
    pom.x+=stredy[j].x*dlz[j];
    pom.y+=stredy[j].y*dlz[j];
    pom.z+=stredy[j].z*dlz[j];
    };

  pom.x/=sucet;
  pom.y/=sucet;
  pom.z/=sucet;

  return pom;
}
//---------------------------------------------------------------------------

bod stolicka::tazisko_opor_bodov()
{
  //pocita aritmeticky priemer opornych bodov
  int i;
  bod pom;

  pom.x=0;
  pom.y=0;
  pom.z=0;

  for(i=0;i<pocmin;i++){
    pom.x+=opor_body[i].x;
    pom.y+=opor_body[i].y;
    pom.z+=opor_body[i].z;
    };

  pom.x/=pocmin;
  pom.y/=pocmin;
  pom.z/=pocmin;

  return pom;
}
//---------------------------------------------------------------------------

stolicka* stolicka::zduplikuj_sa()
{
  //zduplikuje stolicku
  stolicka *st;

  st=new stolicka(nast,symetria,symetria4,stol);

  posuny->zduplikuj_sa(st->posuny);

  st->vyrataj_body();

  return st;
}
//---------------------------------------------------------------------------

int stolicka::length()
{
  if(symetria)return 2*posuny->pocet_zaznamov;
  if(symetria4)return 4*posuny->pocet_zaznamov;
  return posuny->pocet_zaznamov;
}

void stolicka::uloz_do_suboru(AnsiString filename)
{
  uloz *ukladanie;

  ukladanie=new uloz();
  ukladanie->uloz_do_suboru(posuny->koren,filename,symetria,symetria4,stol);

  delete ukladanie;
}
//---------------------------------------------------------------------------

void stolicka::nacitaj_zo_suboru(AnsiString filename)
{
  uloz *ukladanie;

  ukladanie=new uloz();
  posuny->koren=ukladanie->nacitaj_zo_suboru(filename);
  posuny->aktualne=false;

  symetria=ukladanie->symetria;
  symetria4=ukladanie->symetria4;
  stol=ukladanie->doska;

  delete ukladanie;

  vyrataj_body();
}

//---------------------------------------------------------------------------

bool stolicka::plocha_je_sedatko(int x)
{
  int i;

  for(i=0;i<pocet_sedatok;i++)
    if(sedatka[i]==x)return true;

  return false;
}
//---------------------------------------------------------------------------

float vzdialenost_bodov_bez_y(bod b1, bod b2)
{
  float pom;

  pom=(b1.x-b2.x)*(b1.x-b2.x)+(b1.z-b2.z)*(b1.z-b2.z);
  if(pom<eps)
    pom=0;

  return sqrt(pom);
}
//---------------------------------------------------------------------------

float vzdialenost_bodov(bod b1, bod b2)
{
  float pom;

  pom=(b1.x-b2.x)*(b1.x-b2.x)+(b1.y-b2.y)*(b1.y-b2.y)+(b1.z-b2.z)*(b1.z-b2.z);
  if(pom<eps)
    pom=0;

  return sqrt(pom);
}



