//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "strom.h"
#include "matica.h"
#include <stdio.h>

//---------------------------------------------------------------------------

#pragma package(smart_init)

strom::strom()
{
  koren=new zoznam();
  pocet_ciar=0;
  pocet_ploch=0;
  pocet_moznych_ciar=0;
  pocet_zaznamov=0;
  aktualne=false;
}
//---------------------------------------------------------------------------

strom::~strom()
{
  zrus_zoznam(koren);
}
//---------------------------------------------------------------------------

void strom::zrus_zoznam(zoznam *zoz)
{
  element pom;
  int i;

  while(!zoz->is_empty()){
    pom=zoz->pop();
    if(pom.plocha>0){
      for(i=0;i<pom.plocha;i++)
        zrus_zoznam(pom.nasledovnici[i]);
      };
    };
  delete zoz;
}
//---------------------------------------------------------------------------

zoznam* strom::najdi_zoznam_na_krizenie(zoznam *zoz)
{
  int i,j;
  element pom;
  int x;
  zoznam *pomzoz;

  if(pompoc==0)return zoz;
  pomzoz=NULL;
  pompoc-=1;   //pocitadlo zoznamov, ktore sa mozu dat na krizenie

  x=zoz->length();
  zoz->reset();
  for(i=0;i<x;i++){
    pom=zoz->return_value();
    if(pom.plocha>0)
      for(j=0;j<pom.plocha;j++)
          pomzoz=najdi_zoznam_na_krizenie(pom.nasledovnici[j]);  //rekurzivne volanie na vetvenie na ploche
    if(pomzoz!=NULL)return pomzoz;
    };

  return NULL;
}
//---------------------------------------------------------------------------

zoznam* strom::zoznam_na_krizenie()
{
  zoznam *zoz;

  pompoc=random(pocet_ciar+pocet_moznych_ciar);   //nahodne sa zvoli poradove cislo zoznamu, ktory sa bude krizit
  zoz=najdi_zoznam_na_krizenie(koren);

  odkrojeny=zoz;
  aktualne=false;

  return zoz;
}
//---------------------------------------------------------------------------

void strom::pridaj_po_krizeni(prvok *uk)
{
  odkrojeny->pridaj_na_koniec(uk);
  aktualne=false;
}
//---------------------------------------------------------------------------

void strom::mutuj_zoznam(zoznam *zoz)
{
  int i,l,j;
  element p;

  //mutovanie hodnot v posunoch
  l=zoz->length();
  zoz->reset();

  for(i=0;i<l;i++){
    p=zoz->vrat_hodnotu_akt_prvku();
    if(random(100)<p_mut){
      if(random(100)<p_mut*10){
        p.pos.x+=(random(200)/100.0-1)/10.0;
        };
      if(random(100)<p_mut*10){
        p.pos.y+=(random(200)/100.0-1)/10.0;
        };
      if(random(100)<p_mut*10){
        p.pos.z+=(random(200)/100.0-1)/10.0;
        };
      zoz->zmen_akt_prvok(p);
      };

    if(p.plocha>0)
      for(j=0;j<p.plocha;j++)
        if(!p.nasledovnici[j]->is_empty())mutuj_zoznam(p.nasledovnici[j]);

    p=zoz->return_value();
  };
}
//---------------------------------------------------------------------------

void strom::mutuj_strom()
{
  mutuj_zoznam(koren);
  aktualne=false;
}
//---------------------------------------------------------------------------

void strom::zduplikuj_zoznam(zoznam *zoz1, zoznam *zoz2) //da obsah zoz1 do zoz2
{                                                        //predpokladame, ze zoz2 je prazdny
  element pom;
  int i,j;
  zoznam *pomzoz;

  zoz1->reset();

  for(i=0;i<zoz1->length();i++){
    pom=zoz1->return_value();
    if(pom.plocha>0)
      for(j=0;j<pom.plocha;j++){    //ak je tam plocha
        pomzoz=new zoznam();
        if(!pom.nasledovnici[j]->is_empty())
          zduplikuj_zoznam(pom.nasledovnici[j],pomzoz);
        pom.nasledovnici[j]=pomzoz;
        };
    zoz2->push(pom);
    };
}
//---------------------------------------------------------------------------

void strom::zduplikuj_sa(strom *s)
{
  zduplikuj_zoznam(koren,s->koren);
}
//---------------------------------------------------------------------------

posun strom::nahodny_posun()
{
  posun p;

  p.x=random(400)/100.0-2;
  p.y=random(400)/100.0-2;
  p.z=random(400)/100.0-2;

  return p;
}
//---------------------------------------------------------------------------

element strom::nahodny_element(int vn)
{
  //vyrobenie nahodenho elementu, rekurzivna procedura.. vyraba strom
  element pom,pom2;
  int i,j,k,dlz;
  posun pompos;

  pom.pos=nahodny_posun();
  pom.plocha=0;

  if(random(100)<p_plochy)
    pom.plocha=random(max_velkost_plochy);
//    pom.plocha=1;
  if(pom.plocha>0)pocet_ploch+=1;
    for(j=0;j<pom.plocha;j++){
      pom.posuny_plochy[j]=nahodny_posun();
      pom.nasledovnici[j]=new zoznam();
      dlz=random(priem_dlzka)/vn;          //dlzka zoznamov klesa, ked sa vnarame hlbsie - obmedzenie na velkost nahodneho stromu
      if(dlz==0)pocet_moznych_ciar+=1;
      else pocet_ciar+=1;
      for(k=0;k<dlz;k++){
        pom2=nahodny_element(vn+1);
        pom.nasledovnici[j]->push(pom2);
        };
      };

  return pom;
}
//---------------------------------------------------------------------------

void strom::napln_nahodne()
{
  int poc;
  int i;

 // poc=random(5)+2;
  poc=6;

  pocet_ciar=0;
  pocet_ploch=0;
  pocet_moznych_ciar=0;

  if(poc>0)pocet_ciar=1;
  for(i=0;i<poc;i++)
    koren->push(nahodny_element(2));

  aktualne=false;
}
//---------------------------------------------------------------------------

bool strom::is_empty()
{
  return koren->is_empty();
}
//---------------------------------------------------------------------------

vektor strom::otocenie(vektor predch, vektor na_otocenie)
{
  //otaca vektor na_otocenie vzhladom na vektor predch
  matica *m;
  float pompole1[9]={1,0,0,0,1,0,0,0,1};
  float a,b,c,det,vel;
  vektor pom;

  a=predch.data[0];
  b=predch.data[1];
  c=predch.data[2];

  //vyrabanie maticke zobrazenia, pomocou ktorej sa vektor otoci
  if((fabs(b)<eps)&&(fabs(c)<eps)&&(a<eps)){
    Application->MessageBox("Nevhodn vektor na otanie","Chyba", MB_OK);
    abort();
    };

  if((fabs(b)<eps)&&(fabs(c)<eps)&&(a>eps)){
    m=new matica(pompole1);
    m->vynasob(a);
    };

  if((fabs(b)<eps)&&(fabs(c)>=eps)){
    float p[]={a,0,c,0,1,0,c,0,-a};
    m=new matica(p);
    };

  if(fabs(b)>=eps){
    float pp[]={a,       b,      c,
                -b*b-c*c,a*b,    a*c,
                -c*c*c/b,a*c-c/b,1+c*c*a/b};
    m=new matica(pp);
    };


  det=m->determinant();

  det=pow(fabs(det),1/3.0);

  m->vynasob(1/det);

  //otocenie vektora
  pom=m->vynasob_vektorom(na_otocenie);

  vel=velkost_vektora(na_otocenie)/velkost_vektora(pom);

  //vypocet zloziek vektora po otoceni
  pom.data[0]*=vel;
  pom.data[1]*=vel;
  pom.data[2]*=vel;

  delete m;

  return pom;

};
//---------------------------------------------------------------------------

bod strom::nasledujuci_bod(bod bod1, bod bod2, posun dalsi)
{
  //pocita suradnice nasledujuceho bodu, poradie bodov: (bod2, bod1, tento bod)
  vektor predch,pom,na_otoc;
  bod pombod;

  predch.data[0]=bod2.x-bod1.x;
  predch.data[1]=bod2.y-bod1.y;
  predch.data[2]=bod2.z-bod1.z;

  na_otoc.data[0]=dalsi.x;
  na_otoc.data[1]=dalsi.y;
  na_otoc.data[2]=dalsi.z;

  pom=otocenie(predch,na_otoc);

  pombod.x=bod2.x+pom.data[0];
  pombod.y=bod2.y+pom.data[1];
  pombod.z=bod2.z+pom.data[2];

  return pombod;
}
//---------------------------------------------------------------------------

void strom::spracuj_zoznam(zoznam *zoz, bod bod1, bod bod2)    //bod2 - zaciatok novej ciary
{
  //spracuje jeden zoznam pri pprevadzani genotypu na fenotyp
  int i,akt,d; //akt zaznam
  element data;

  zoz->reset();

  akt=pocet_zaznamov;  //akt je nablizsi volny riadok
  pocet_zaznamov+=1;   //pridame riadok do pola utvary
  if(pocet_zaznamov>99){
    Application->MessageBox("Vea zznamov v strome","Chyba",MB_OK);
    abort();
    };  
  pocet_ciar+=1;

  d=zoz->length();
  dlzky[akt]=d+1;
  utvary[akt][0]=bod2;

  //spracovanie prveho prvku, musi sa spracovavat samostatne, lebo sa tu pouziva bod1, ktory nie je sucastou tejto ciary
  data=zoz->return_value();
  utvary[akt][1]=nasledujuci_bod(bod1,bod2,data.pos);
  if(data.plocha>0)spracuj_plochu(data,utvary[akt][0],utvary[akt][1]);

  //spracovanie dalsich prvkov
  for(i=2;i<d+1;i++){
    data=zoz->return_value();
    utvary[akt][i]=nasledujuci_bod(utvary[akt][i-2],utvary[akt][i-1],data.pos);
    if(data.plocha>0)spracuj_plochu(data,utvary[akt][i-1],utvary[akt][i]);
    };

}
//---------------------------------------------------------------------------

void strom::spracuj_plochu(element el, bod bod1, bod bod2)
{
  //spracuje jednu plochu pri prevode genotypu na fenotyp
  int i,akt;
  vektor pom,predch;

  akt=pocet_zaznamov;
  pocet_zaznamov+=1;     //pridanie riadku do pola utvary
  if(pocet_zaznamov>99){
    Application->MessageBox("Vea zznamov v strome","Chyba",MB_OK);
    abort();
    };
  pocet_ploch+=1;

  dlzky[akt]=el.plocha+2+100;
  utvary[akt][0]=bod1;
  utvary[akt][1]=bod2;

  for(i=2;i<el.plocha+2;i++){
    utvary[akt][i]=nasledujuci_bod(utvary[akt][i-2],utvary[akt][i-1],el.posuny_plochy[i-2]);
    if(!el.nasledovnici[i-2]->is_empty())
      spracuj_zoznam(el.nasledovnici[i-2],utvary[akt][i-1],utvary[akt][i]);
    else pocet_moznych_ciar+=1;
    };

}
//---------------------------------------------------------------------------

void strom::vyrataj_body()
{
  bod zaciatok,pom;

  if(koren->is_empty()){
    pocet_zaznamov=0;
    pocet_ciar=0;
    pocet_ploch=0;
    pocet_moznych_ciar=1;
    return;
    };

  pom.x=1;
  pom.y=0;
  pom.z=1;

  zaciatok.x=0;
  zaciatok.y=0;
  zaciatok.z=0;

  pocet_zaznamov=0;
  pocet_ciar=0;
  pocet_ploch=0;
  pocet_moznych_ciar=0;

  spracuj_zoznam(koren, pom, zaciatok);

  aktualne=true;
}
//---------------------------------------------------------------------------

int* strom::vrat_dlzky()
{
  if(!aktualne)
    vyrataj_body();

  return dlzky;
}
//---------------------------------------------------------------------------

bod* strom::vrat_utvary()
{
  if(!aktualne)
    vyrataj_body();

  return utvary[0];
}

//---------------------------------------------------------------------------

float velkost_vektora(vektor v)
{
  float pom;

  pom=v.data[0]*v.data[0]+v.data[1]*v.data[1]+v.data[2]*v.data[2];
  if(pom<eps)pom=0;

  return sqrt(pom);
}
