//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "ukladanie.h"
#include <io.h>


//---------------------------------------------------------------------------

#pragma package(smart_init)

uloz::uloz()
{
  pocet=0;
  symetria=false;
  symetria4=false;
}
//---------------------------------------------------------------------------

int uloz::daj_do_pola(prvok *p)         //ulozi prvky stromu do pola
{
  int pom,i;

  pom=pocet;
  pompole[pocet].data=p->data;
  pocet+=1;

  if(p->next!=NULL)pompole[pom].next=daj_do_pola(p->next);      //ak ma prvok nasledovnika, vloz ho do pola
  else pompole[pom].next=-1;                                    //ak nie, daj do nasledovnika -1

  if(pompole[pom].data.plocha>10){
    Application->MessageBox("Vea bodov v ploche pri ukladan","Chyba",MB_OK);
    abort();
    };

  //ak prvok obsahuje plochu, tak spracuj zoznamy, ktore su na nej zavesene
  for(i=0;i<p->data.plocha;i++)
    if(!p->data.nasledovnici[i]->is_empty())
      pompole[pom].nasledovnici[i]=daj_do_pola(p->data.nasledovnici[i]->zaciatok());
    else pompole[pom].nasledovnici[i]=-1;  

  return pom;
}
//---------------------------------------------------------------------------

void uloz::spracuj_prvok(zoznam *zoz, int x)   //prvok v pompole[x] vlozi do zoznamu zoz a ak je to plocha tak ju spracuje
{
  element pom;
  int i;

  //nacitaj data z pola
  pom=pompole[x].data;

  //ak je v tomto prvku aj rovina, tak ju spracuj, t.j. vyrob zoznamy, ktore maju byt zavesene na rovine
  if(pom.plocha>0)
    for(i=0;i<pom.plocha;i++){
      pom.nasledovnici[i]=new zoznam();
      if(pompole[x].nasledovnici[i]>-1)
        spracuj_prvok(pom.nasledovnici[i],pompole[x].nasledovnici[i]);
      };

  //vloz novovytovreny prvok do zoznamu
  zoz->push(pom);
  if(pompole[x].next>-1)spracuj_prvok(zoz,pompole[x].next);     //ak ma prvok nasledovnika, spracuj ho
}
//---------------------------------------------------------------------------

zoznam* uloz::vyrob_strom()
{
  //vyraba strom z pola pompole
  zoznam *pomzoz;

  if(pocet==0)return NULL;

  pomzoz=new zoznam();
  spracuj_prvok(pomzoz,0);

  return pomzoz;
}
//---------------------------------------------------------------------------

void uloz::uloz_do_suboru(zoznam *zac, AnsiString filename, bool sym, bool sym4, bool doska)
{
  TFileStream *subor;
  int i;

  if(zac->is_empty()){
    Application->MessageBox("Nevidm dvod uklada przdnu stoliku :)","Chyba", MB_OK);
    return;
    };

  //vyrobime pole pompole zo stromu stolicky, ktoru ideme ukladat na disk
  daj_do_pola(zac->zaciatok());

  subor=new TFileStream(filename,fmCreate);

  //zapiseme chrakateristiky, akymi sa maju spracovavat dalsie ulozene data
  subor->Write(&sym,sizeof(bool));
  subor->Write(&sym4,sizeof(bool));
  subor->Write(&doska,sizeof(bool));

  //zapis dat zo stromu
  for(i=0;i<pocet;i++)
    subor->Write(&pompole[i],sizeof(strom_pole));

  delete subor;
}
//---------------------------------------------------------------------------

void uloz::reset()
{
  pocet=0;
}
//---------------------------------------------------------------------------

zoznam* uloz::nacitaj_zo_suboru(AnsiString filename)
{
  TFileStream *subor;

  if(!FileExists(filename)){
     Application->MessageBox("Nemem otvori neexistujci sbor","Chyba", MB_OK);
     return new zoznam();
     };

  subor=new TFileStream(filename,fmOpenRead);

  reset();

  //nacitanie charakteristik ulozenej stolicky
  subor->Read(&symetria,sizeof(bool));
  subor->Read(&symetria4,sizeof(bool));
  subor->Read(&doska,sizeof(bool));

  //nacitanie dat zo suboru do pola
  while(subor->Position<subor->Size){
    subor->Read(&pompole[pocet],sizeof(strom_pole));
    pocet+=1;
    };

  delete subor;

  //vyrobime z nacitaneho pola strom
  return vyrob_strom();
}
