//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "zoznam.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

zoznam::zoznam()
{
  zac=NULL;
  akt=zac;
  dlzka=0;
  kon=zac;
}
//---------------------------------------------------------------------------

zoznam::~zoznam()
{
  while(!is_empty()){
    pop();
    };
}
//---------------------------------------------------------------------------

prvok* zoznam::zaciatok()
{
  return zac;
}
//---------------------------------------------------------------------------

bool zoznam::is_empty()
{
  return zac==NULL;
}
//---------------------------------------------------------------------------

void zoznam::push(element data)
{
  prvok *pom;

  pom=new prvok;
  pom->data=data;
  pom->next=NULL;

  if(is_empty()){
    zac=pom;
    kon=pom;
    }
  else kon->next=pom;

  kon=pom;
  dlzka+=1;
}
//---------------------------------------------------------------------------

element zoznam::pop()
{
  prvok *pom;
  element p;

  if(is_empty()){
    Application->MessageBox("Pokus o pop z przdneho zoznamu","Chyba", MB_OK);
    abort();
    };

  pom=zac;
  zac=pom->next;
  p=pom->data;
  akt=zac;
  delete pom;
  dlzka-=1;

  return p;
}
//---------------------------------------------------------------------------

void zoznam::reset()
{
  akt=zac;
}
//---------------------------------------------------------------------------

int zoznam::length()
{
  if(dlzka>50)Application->MessageBox("Prli dlh zoznam","Chyba", MB_OK);
  return dlzka;
}
//---------------------------------------------------------------------------

bool zoznam::is_end()
{
  return akt==NULL;
}
//---------------------------------------------------------------------------

element zoznam::return_value()
{
  if(is_end()){
    Application->MessageBox("Pokus o tanie za koncom zoznamu","Chyba", MB_OK);
    abort();
    };

  element pom;

  pom=akt->data;
  akt=akt->next;

  return pom;
}
//---------------------------------------------------------------------------

prvok* zoznam::kus_zoznamu()
{
  int poc,i;
  prvok *pom;

  poc=random(dlzka+1);    //pocet prvkov, ktore zostanu v zozname

  if(poc==0){
    pom=zac;
    zac=NULL;
    dlzka=0;
    akt=zac;
    kon=zac;
    return pom;
    };

  reset();

  for(i=0;i<poc-1;i++)
    return_value();

  pom=akt->next;
  akt->next=NULL;
  kon=akt;
  refresh();

  return pom;
}
//---------------------------------------------------------------------------

void zoznam::pridaj_na_koniec(prvok *ukaz)
{
  if(is_empty()){
    zac=ukaz;
    akt=zac;
    }
  else{
    kon->next=ukaz;
    };

  refresh();

  while(dlzka>50)pop();
}
//---------------------------------------------------------------------------

element zoznam::vrat_hodnotu_akt_prvku()
{
  if(akt==NULL){
    Application->MessageBox("tanie przdneho aktulneho prvku","Chyba", MB_OK);
    abort();
    };
  return akt->data;
}
//---------------------------------------------------------------------------

void zoznam::zmen_akt_prvok(element pos)
{
  if(akt==NULL){
    Application->MessageBox("Zapisovanie przdneho aktulneho prvku","Chyba", MB_OK);
    abort();
    };
  akt->data=pos;
}
//---------------------------------------------------------------------------

void zoznam::refresh()
{
  int pom=0;

  if(is_empty()){
    kon=zac;
    akt=zac;
    dlzka=0;
    return;
    };

  reset();

  //prejdeme cely zoznam a nastavime spravne hodnoty pointra kon a dlzku zoznamu
  while(akt!=NULL){
    pom+=1;
    kon=akt;
    return_value();
    };
  akt=zac;

  dlzka=pom;

  return ;
}
